import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'starxpandprinter_method_channel.dart';

abstract class StarxpandprinterPlatform extends PlatformInterface {
  /// Constructs a StarxpandprinterPlatform.
  StarxpandprinterPlatform() : super(token: _token);

  static final Object _token = Object();

  static StarxpandprinterPlatform _instance = MethodChannelStarxpandprinter();

  /// The default instance of [StarxpandprinterPlatform] to use.
  ///
  /// Defaults to [MethodChannelStarxpandprinter].
  static StarxpandprinterPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [StarxpandprinterPlatform] when
  /// they register themselves.
  static set instance(StarxpandprinterPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
